/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package servlets;

import hibernate.Userdata;
import hibernate.util.HibernateUtil;
import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.hibernate.Session;
import util.ConvertPassword;

/**
 *
 * @author Ani
 */
public class ChangePassword extends HttpServlet {
   
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();

        try {
            Userdata ud = (Userdata) request.getSession().getAttribute("loggedUser");
            if (!ud.getPassword().getPassword().equals(ConvertPassword.convertPassword(request.getParameter("oldPw")))){
                request.getSession().setAttribute("message", "Nem ez volt a \"régi\" jelszavad!");
            }
            else if (!request.getParameter("newPw").equals(request.getParameter("newPwAgain"))){
                request.getSession().setAttribute("message", "A jelszavak nem egyeznek!");
            }
            else if (request.getParameter("newPw").length()<6){
                request.getSession().setAttribute("message", "A jelszó nem elég hosszú!");
            }
            else{
                ud.getPassword().setPassword(ConvertPassword.convertPassword(request.getParameter("newPw")));
                Session hsession = (Session) HibernateUtil.getSessionFactory().openSession();
                hsession.beginTransaction();
                hsession.update(ud.getPassword());
                hsession.getTransaction().commit();
                hsession.close();
                request.getSession().setAttribute("message", "Sikeres jelszóváltoztatás!");
            }
            response.sendRedirect("changepassword.jsp");
        } catch(Exception ex){

        } finally {
            out.close();
        }
    } 

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
